#include <QTRSensors.h>
#include <ZumoReflectanceSensorArray.h>
#include <ZumoMotors.h>
#include <ZumoBuzzer.h>
#include <Pushbutton.h>


#define proxPin 18

#define thresh 1000

ZumoBuzzer buzzer;
ZumoReflectanceSensorArray reflectanceSensors;
ZumoMotors motors;
Pushbutton button(ZUMO_BUTTON);
int lastError = 0;
int proxval = 0;

long duration;

bool send_ser;
int fresh;
int inByte;

// This is the maximum speed the motors will be allowed to turn.
// (400 lets the motors go at top speed; decrease to impose a speed limit)
const int MAX_SPEED = 400;

void setup()
{
  // Play a little welcome song
  buzzer.play(">g32>>c32");

  // Initialize the reflectance sensors module
  reflectanceSensors.init();

  //Serial.begin(115200);
  //Serial.print("my eyes!");

  // Wait for the user button to be pressed and released
  button.waitForButton();

  //pinMode(trigPin, OUTPUT);
  pinMode(proxPin, INPUT);

  // Turn on LED to indicate we are in calibration mode
  pinMode(13, OUTPUT);
  digitalWrite(13, HIGH);


  motors.setSpeeds(-400, 400);
  delay(2000);
  buzzer.play(">g32>>c32");
  motors.setSpeeds(400, -400);
  delay(2000);
  motors.setSpeeds(0, 0);
  buzzer.play(">g32>>c32");

  Serial.begin(115200);
  Serial.print("Z34 serial");
  Serial.print("\n");

  digitalWrite(13, LOW);
  button.waitForButton();
}

void loop()
{
  //digitalWrite(trigPin, LOW);  // Added this line
  //delayMicroseconds(2); // Added this line
  //digitalWrite(trigPin, HIGH);
//  delayMicroseconds(1000); - Removed this line
  //delayMicroseconds(10); // Added this line
  //digitalWrite(trigPin, LOW);
  //duration = pulseIn(echoPin, HIGH);
  /* Serial.print(duration); */
  /* Serial.print("\n"); */
  /* Serial.print("----"); */
  /* Serial.print("\n"); */
  delay(100);
  proxval = digitalRead(proxPin);
  //proxval = 1;
  if (proxval == 0){
    digitalWrite(13, HIGH);
    motors.setSpeeds(0, 0);
    delay(100);
    motors.setSpeeds(400,-400);
    delay(300);
    motors.setSpeeds(0, 0);
  }
  else{
    digitalWrite(13, LOW);
    motors.setSpeeds(MAX_SPEED, MAX_SPEED);
  }
  //---------------------
  /* motors.setSpeeds(MAX_SPEED, MAX_SPEED); */
  /* delay(1000); */
  /* motors.setSpeeds(400,-400); */
  /* delay(700); */
  //---------------------
  /* motors.setSpeeds(MAX_SPEED, MAX_SPEED); */
  /* delay(1000); */
  /* motors.setSpeeds(-400,400); */
  /* delay(700); */
  delay(100);
  if (Serial.available() > 0) {
    inByte = Serial.read();
    Serial.println("hello from serial receive");
    if (inByte == 1){
      //main control case
      //send_ser = true;
      Serial.println("case 1:");
      fresh = 1;
    }
  }//end if available
  
}